#!/usr/bin/env python

import subprocess as sp

tty_r = open('/dev/tty', 'r')
tty_w = open('/dev/tty', 'w')

def get_sz():
	w = int( sp.check_output('tput cols', shell=True).strip() )
	h = int( sp.check_output('tput lines', shell=True).strip() )
	return (w, h)

def get_pos():
	cmds = [
		#'echo -en "\e[6n"',
		'echo -en "\x1b[6n"',
		'read -sd"[" dmy',
		'read -sd"R" row_col',
		'echo -n $row_col >&2',
	]
	cmd = "bash -c '{}'".format( '\n'.join(cmds) )

	proc = sp.Popen(cmd, shell=True, stdin=tty_r, stdout=tty_w, stderr=sp.PIPE)
	s = proc.communicate()[1].decode()
	proc.wait()

	(row, col) = map( int, s.split(';') )
	(x, y) = (col-1, row-1)
	return (x, y)

def stty(s, v=True):
	if not v:
		s = '-' + s
	cmd = 'stty {} < /dev/tty'.format(s)
	sp.call( cmd, shell=True )

def out(s):
	tty_w.write(s)
	tty_w.flush()

esc = lambda s: chr(0x1b) + '[' + s
esc_ex = lambda d, v: esc( '?{}{}'.format(d, 'h' if v else 'l' ) )

loc = lambda x, y: out( esc( '{};{}H'.format(y+1, x+1) ) )
rev = lambda : out( esc('7m') )
uline = lambda : out( esc('4m') )
reset = lambda : out( esc('0m') )
cls = lambda : out( esc('2J') )
cursor_show = lambda v: out( esc_ex(25, v) )

def scroll(m):
	am = abs(m)
	sm = m / am
	v = 'S' if sm > 0 else 'T'
	out( esc( '{}{}'.format( am, v ) ) )
# EOF
