import term
import rect

class Empty:
	pass

is_k1 = lambda c: ord(c) >= 0x80
k2 = chr(0)

def adj_line(s):
	for i in range( len(s)-1 ):
		(c0, c1) = s[i:i+2]
		if is_k1(c0) and c1 != k2:
			s = s[:i] + ' ' + s[i+1:]
		if not is_k1(c0) and c1 == k2:
			s = s[:i+1] + ' ' + s[i+2:]
	if s[0] == k2:
		s = ' ' + s[1:]
	if is_k1( s[-1] ):
		s = s[:-1] + ' '
	return s

def new(r):
	e = Empty()
	(rx, ry, rw, rh) = r
	arr_r = (rx-1, ry, rw+2, rh)

	e.rev = term.esc('7m')
	e.uline = term.esc('4m')
	e.reset = term.esc('0m')

	e.arr = list( map( lambda i: ' ' * (rw+2), range(rh) ) )
	e.att = list( map( lambda i: [[]] * (rw+2), range(rh) ) )

	to_idx = lambda x, y: ( x - rx + 1, y - ry )
	idx_to = lambda x, y: ( x - 1 + rx, y + ry )

	def set(x, y, s, atts=[]):
		s = ''.join( map( lambda c: c+k2 if is_k1(c) else c, s ) )

		(bx, by) = x, y
		r = (x, y, len(s), 1)

		(x, y, w, h) = r = rect.op_and(r, arr_r)
		if not rect.is_area(r):
			return

		if x > bx:
			s = s[ x-bx : ]
		if w < len(s):
			s = s[ : w-len(s) ]

		(ix, iy) = to_idx(x, y)
		l = e.arr[iy]
		e.arr[iy] = l[:ix] + s + l[ix+w:]

		e.att[iy][ix:ix+w] = [atts] * w
	e.set = set

	def adjust():
		e.arr = list( map( adj_line, e.arr ) )
	e.adjust = adjust

	def get_line(y): # return (x, s)
		(ix, iy) = to_idx(rx, y)
		s = e.arr[iy]

		x = rx
		(c0, c1) = s[:2]
		if is_k1(c0) and c1 == k2:
			x -= 1
		else:
			s = s[1:]

		(c0, c1) = s[-2:]
		if is_k1(c0) and c1 == k2:
			pass
		else:
			s = s[:-1]

		ix -= rx - x
		bak = []
		mix = ''
		for i in range( len(s) ):
			a = e.att[iy][ix+i]
			if a != bak:
				if bak or a == []:
					mix += e.reset
				mix += ''.join(a)
				bak = a
			mix += s[i]
		if bak:
			mix += e.reset

		mix = ''.join( map( lambda c: '' if c == k2 else c, mix ) )
		return (x, mix)
	e.get_line = get_line

	def txt_out(): # for all area
		ss = []
		for i in range(rh):
			(_, s) = get_line(ry+i)
			while s[-1:] in (' ', '\t'):
				s = s[:-1]
			ss += [s]
		return '\n'.join(ss)
	e.txt_out = txt_out

	return e
# EOF
